//////////////////////////////////////////////////////////////////
//
//  HB100 Doppler Frequency and Speed Measurement Demo
//
//  Frequency input pin: D8
//      Connect to Amplified IF (mixer output) signal from HB100 
//      See HackerBox #0071 
// 
//  Free to use, modify, distribute
//  Inspired by public domain code from PJRC and @3zuli
//
//////////////////////////////////////////////////////////////////

#include <FreqMeasure.h>

void setup() {
  Serial.begin(115200);
  FreqMeasure.begin();
}

double sum=0;
int count=0;

void loop() {
  if (FreqMeasure.available()) {
    // average 30 readings together
    sum = sum + FreqMeasure.read();
    count = count + 1;
    if (count > 30) {
      float frequency = FreqMeasure.countToFrequency(sum / count);
      float kph = frequency / 19.49;
      float mph = kph * 0.621371;
      Serial.print("Freq: ");
      Serial.print(frequency);
      Serial.print("Hz");
      Serial.print("       ");
      Serial.print(mph);
      Serial.print("mph");
      Serial.print("       ");
      Serial.print(kph);
      Serial.println("km/h");
      sum = 0;
      count = 0;
    }
  }
}
